<html>
<head>
<title>BMRT Documentation</title>
</head>
<body>

<center>
<h1>Blue Moon Rendering Tools 2.4
<p>Part 7: Miscellaneous Tools and Goodies</h1>
<h3>

<h1><br></h1>

<p>revised 27 August 1998
<p>
<h1><br></h1>

<p>Larry I. Gritz
<br>
gritzl@acm.org
<br>
</h3></center>

<h1><br></h1>

<hr>


<h3>7.1 Parsing Shader Arguments with libslcargs.a</h3>

<p>Pixar's <em>PhotoRealistic RenderMan</em> implementation provides a
linkable library which allows a developer to read a compiled shader
file (.slo) to determine what type of shader it is and what parameter
names and defaults belong to that shader.  Since Pixar's .slo format
is different from BMRT's .slc format, a similar library is provided to
parse the .slc files.  The library is libslcargs.a, and the C language
header file is slc.h.  The slc.h file should be fairly self-documenting,
and certainly anybody with experience using Pixar's libsloargs.a
library ought to have an easy time of using libslcargs.a.

<h3>7.2 Using <em>slctell</em> to list shader arguments</h3>

Another binary, <em>slctell</em>, reports the type of shader and its
parameter names and default values.  Usage is simple: just give the
shader name on the command line (NOT the file name).  For example,

<pre>
	slctell plastic
</pre>

reports:

<pre>
	surface "shaders/plastic"
	    "Ka" "uniform float"
	                Default value: 1
	    "Kd" "uniform float"
	                Default value: 0.5
	    "Ks" "uniform float"
	                Default value: 0.5
	    "roughness" "uniform float"
	                Default value: 0.1
	    "specularcolor" "uniform color"
	                Default value: "rgb" [1 1 1]
</pre>



<h3>7.3 Simple Image Compositing with <em>composite</em></h3>

<p>Starting with release 2.3.6, BMRT includes a program to perform
elementary image compositing operations.  If you render your images
with alpha channels (i.e. "rgba"), then coverage information will be
stored with every pixel in the image.  For the purposes of
<em>composite</em>, RGB images without alpha channels will be assumed
to have an alpha of 1.0 at every pixel.

<p><em>composite</em> may be run as follows:

<dl>
<dt><tt>composite</tt> <em>file1</em> <tt>over</tt> <em>file2</em> <tt>-o</tt> <em>output</em>
<dt><tt>composite</tt> <em>file1</em> <tt>in</tt> <em>file2</em> <tt>-o</tt> <em>output</em>
<dt><tt>composite</tt> <em>file1</em> <tt>out</tt> <em>file2</em> <tt>-o</tt> <em>output</em>
<dt><tt>composite</tt> <em>file1</em> <tt>atop</tt> <em>file2</em> <tt>-o</tt> <em>output</em>
<dt><tt>composite</tt> <em>file1</em> <tt>xor</tt> <em>file2</em> <tt>-o</tt> <em>output</em>

<dd>Composite images <em>file1</em> and <em>file2</em> using one of
the standard image compositing operators described in (Porter & Duff,
"Digital Image Compositing", Proceedings of SIGGRAPH '84,
pp. 253-259), storing the composited image in file <em>output</em>.<p>

<dt><tt>composite</tt> <em>file1</em> <tt>plus</tt> <em>file2</em> <tt>-o</tt> <em>output</em>
<dt><tt>composite</tt> <em>file1</em> <tt>minus</tt> <em>file2</em> <tt>-o</tt> <em>output</em>

<dd>Add or subtract two files, storing the results in file
<em>output</em>.  Pixels are clamped to [0,maxval], where maxval==255
for 8 bit images, maxval==65535 for 16 bit images.<p>

<dt><tt>composite</tt> <em>file1</em> <tt>scale</tt> <em>float</em> <tt>-o</tt> <em>output</em>
<dt><tt>composite</tt> <em>file1</em> <tt>dissolve</tt> <em>float</em> <tt>-o</tt> <em>output</em>
<dt><tt>composite</tt> <em>file1</em> <tt>opaque</tt> <em>float</em> <tt>-o</tt> <em>output</em>

<dd>These three unary operators take a floating point number, rather
than a filename, as their second operand.  They all scale the channels
of the image, but in slightly different ways.  The <tt>scale</tt>
operator multiples the RGB channels, but leaves the alpha alone --
i.e. it can brighten or darken an image without changing its
transparency.  The <tt>dissolve</tt> operator scales the alpha along
with the RGB.  Finally, the <tt>opaque</tt> operator will scale
<em>only</em> the alpha channel.

</dl>
<p><b>Hint for beginners</b>:  you probably want <tt>over</tt>.
<p>



<h3>7.4 Making tiled TIFF files with <em>mkmip</em></h3>

<p>BMRT has always used TIFF files for stored image textures (as
opposed to <em>PRMan</em>, which requires you to convert to a
proprietary texture format).  Beginning with BMRT 2.4, though BMRT
will continue to accept regular scanline (or strip) oriented TIFF
files, it is able to perform certain optimizations if the TIFF files
you supply happen to be tile-oriented.  In particular, BMRT is able
to significantly reduce the memory needed for texture mapping with
tiled TIFF files.

<p>A new program supplied with BMRT, <em>mkmip</em>, can convert
scanline TIFF files into multiresolution, tiled TIFF files.  Command
line usage is:

<pre>
        mkmip [options] infilename outfilename
</pre>

<p>where options include:

<dl>
  <dt><tt>-smode <em>wrapmode</em>
  <br>-tmode <em>wrapmode</em>
  <br>-mode <em>wrapmode</em>
       </tt>
  <dd>where <em>wrapmode</em> is one of:  <tt>periodic</tt>, <tt>black</tt>,
       or <tt>clamp</tt>.  This specifies the behavior of the texture when
       outside the [0,1] lookup range.  Note that <tt>-smode</tt> and
       <tt>-tmode</tt> specify wrapping behavior separately for the s and
       t directions, while <tt>-mode</tt> specifies both at the same time.
</dl>



<p>
<h3>7.5 Setting default options and attributes</h3>

Remember that both of BMRT's renderers (<em>rendrib</em>
and <em>rgl</em>) read from a file called
<tt>.rendribrc</tt> both in the local directory where it is run, and
also in your home directory.  This file can be plain RIB, which means
that if you want to set any defaults (default resolution, shader
search path, texture cache size, etc.) you can just put the Option or
Attribute lines in this file in your home directory.


<h3>7.6 <em>farm</em>: Poor Man's Render Farm</h3>

Many people ask how they can divide rendering of a single frame among
several processors or machines.  Starting with BMRT 2.4, the Perl
script <em>farm</em> accomplishes this task, in a relatively rudimentary
way.

<h4>How to use <em>farm</em></h4>

<ol>
  <li><p> Set the environment variable <code>BMRT_FARM</code> to be a
       blank-separated list of the names of machines which can be
       used as render servers.  Machines with multiple processors should
       be listed multiple times.  For example, if you have a machine
       named "fred" with two processors, and one named "wilma" with
       one processor, then run:
       <p><code>setenv BMRT_FARM "fred fred wilma"</code>
       <p>if you use <code>csh</code>.  If you use <code>sh</code>, try:
       <p><code>export BMRT_FARM="fred fred wilma"</code><p>
  <li><p>  Make sure that <em>rendrib</em> is in the default path of each
       remote machine, and that <em>mkmosaic</em> is in the path
       on the local machine.
  <li><p>  Run farm:
       <p><code>farm myfile.rib</code><p>
</ol>

<h4>What <em>farm</em> does</h4>

<p>First, <em>farm</em> will look at your RIB file to figure out the
resolution and the name of the TIFF file that it will render.  It will
choose an appropriate number of subwindows to render.

<p>One by one, it will send the frame to machines on your
<code>BMRT_FARM</code> list, using the <code>-crop</code> and
<code>-of</code> flags to make <em>rendrib</em> render particular
crop windows.  Machines whose load averages are too high will
automatically refuse the frames.

<p>When <em>farm</em> sees that all the subsections are finished (each
will leave a little file indicating that it's done), it will assemble
all the pieces using the <em>mkmosaic</em> program, and clean up all
the cruft files.


<h4>Important <em>farm</em> restrictions</h4>

<ol>
  <li> Because <em>farm</em> relies on <em>rsh</em>, you can only use
       it on UNIX (or UNIX-like) operating systems.
  <li> You can't use <em>farm</em> to render to the display (the -d flag).
       It must be rendering to a TIFF file.
  <li> Don't try using any other rendrib command line flags.  Request
       all image options (like radiosity options) in the RIB file with
       Option and Attribute statements.
  <li> Hitting Control-C to interrupt <em>farm</em> will kill only
       <em>farm</em>, but will leave the individual crop windows rendering
       on the remote machines.  Beware.
</ol>



<p><hr><p>
<h3><A NAME="refs">References</h3>
<dl>

<dt>[Upstill89]
<dd> Upstill, Steve.  <em>The RenderMan Companion: A Programmer's
Guide to Realistic Computer Graphics</em>.  Addison-Wesley, 1989.

<dt>[Pixar89]
<dd> Pixar.  "The RenderMan Interface, version 3.1 official
specification."  Published by Pixar, 1989.

<dt>[Apodaca90]
<dd> Apodaca, A., ed.  "The RenderMan Interface and Shading
Language," Siggraph '90 course notes (course 18), 1990.

<dt>[Apodaca92]
<dd> Apodaca, A., ed.  "Writing RenderMan Shaders," Siggraph '92
course notes (course 21), 1992.

<dt>[Apodaca95]
<dd> Apodaca, A., ed.  "Using RenderMan for Animation Production,"
Siggraph '95 course notes (course 4), 1995.

<dt>[Apodaca98]
<dd> Apodaca, A. and L. Gritz, eds.  "Advanced RenderMan: Beyond the
Companion" Siggraph '98 course notes (course 11), 1998.

<dt>[Gritz93]
<dd> Gritz, Larry. "Computing Specular-to-Diffuse Illumination for
Two-Pass Rendering," Master's Thesis, The George Washington
University, Dept. of EE & CS, May, 1993.

<dt>[Gritz94]
<dd> Gritz, Larry.  "RenderMan for Poets," Technical Report
GWU-IIST-94-05, Dept. of EE&CS, The George Washington University,
1994.

<dt>[Gritz96] <dd> Gritz, Larry and J. Hahn.  "BMRT: A Global
Illumination Implementation of the RenderMan Standard," <em>Journal of
Graphics Tools</em>, Vol. 1, No. 3, pp. 29-47 (1996).

</dl>



<hr>


<p>This document last updated 27 Aug 98 by <a href="mail:gritzl@acm.org">gritzl@acm.org</a>

<p>All BMRT components are Copyright 1990-1998 by Larry I. Gritz.
All rights reserved.

<p>The RenderMan Interface Procedures and RIB Protocol are:
Copyright 1988, 1989, Pixar.  All rights reserved.
RenderMan is a registered trademark of Pixar.

</body>
</html>
